"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MiddyMiddleware = void 0;
var tslib_1 = require("tslib");
var promisifyMiddyMiddleware_1 = require("./promisifyMiddyMiddleware");
var logger_1 = require("../logger");
var MiddyMiddleware = /** @class */ (function () {
    function MiddyMiddleware(middlewareObject) {
        this.middlewareObject = promisifyMiddyMiddleware_1.promisifyMiddyMiddleware(middlewareObject);
    }
    MiddyMiddleware.prototype.onError = function (instance, defaultReturn) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger_1.logger("Checking for onError middleware");
                        if (this.middlewareObject.onError === undefined) {
                            return [2 /*return*/, defaultReturn];
                        }
                        logger_1.logger("Calling onError middleware");
                        return [4 /*yield*/, this.middlewareObject.onError(instance)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    MiddyMiddleware.prototype.before = function (instance) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, this.run("before", instance)];
            });
        });
    };
    MiddyMiddleware.prototype.after = function (instance) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, this.run("after", instance)];
            });
        });
    };
    MiddyMiddleware.prototype.run = function (middlewareType, instance) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var middleware;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger_1.logger("Checking for " + middlewareType + " middleware");
                        middleware = this.middlewareObject[middlewareType];
                        if (middleware === undefined) {
                            return [2 /*return*/];
                        }
                        logger_1.logger("Calling " + middlewareType + " middleware");
                        return [4 /*yield*/, middleware(instance)];
                    case 1:
                        _a.sent();
                        logger_1.logger(middlewareType + " middleware called");
                        return [2 /*return*/];
                }
            });
        });
    };
    return MiddyMiddleware;
}());
exports.MiddyMiddleware = MiddyMiddleware;
//# sourceMappingURL=MiddyMiddleware.js.map